--[[

	The MIT License (MIT)

	Copyright (c) 2022 Lars Norberg

	Permission is hereby granted, free of charge, to any person obtaining a copy
	of this software and associated documentation files (the "Software"), to deal
	in the Software without restriction, including without limitation the rights
	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	copies of the Software, and to permit persons to whom the Software is
	furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all
	copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
	SOFTWARE.

--]]
local Addon, ns = ...
local WorldMap = ns:NewModule("WorldMap", "LibMoreEvents-1.0")

WorldMap.SetUpWorldMap = function(self)
	if (not WorldMapFrame) then
		self:RegisterEvent("ADDON_LOADED", "OnEvent")
		return
	end
	
	-- This script would taint the Quest Objective Tracker Button
	if (QuestMapFrame) then
		QuestMapFrame.VerticalSeparator:Hide()
		QuestMapFrame:SetScript("OnHide", nil) 
	end

	--local visible
	--WorldMapFrame:HookScript("OnShow", function() 
	--	if (Minimap:IsShown()) then
	--		visible = true
	--	end
	--	Minimap:Hide()
	--end)
	--WorldMapFrame:HookScript("OnHide", function() 
	--	if (visible) then
	--		Minimap:Show()
	--		visible = nil
	--	end
	--end)
end

WorldMap.OnEvent = function(self, event, ...)
	if (event == "ADDON_LOADED") then
		local addon = ...
		if (addon == "Blizzard_WorldMap") then
			self:UnregisterEvent("ADDON_LOADED", "OnEvent")
			self:SetUpWorldMap()
		end
		return
	end
end

WorldMap.OnInitialize = function(self)
	self:SetUpWorldMap()
end
